# This file is a template, and might need editing before it works on your project.
image: golang:latest

variables:
  # Please edit to your GitLab project
  REPO_NAME: gitlab.com/namespace/project
  BINARY_NAME: kubernetes-iam-user-registration

# The problem is that to be able to use go get, one needs to put
# the repository in the $GOPATH. So for example if your gitlab domain
# is gitlab.com, and that your repository is namespace/project, and
# the default GOPATH being /go, then you'd need to have your
# repository in /go/src/gitlab.com/namespace/project
# Thus, making a symbolic link corrects this.
before_script:
  - mkdir -p ${GOPATH}/src/$(dirname ${REPO_NAME})
  - ln -svf ${CI_PROJECT_DIR} ${GOPATH}/src/${REPO_NAME}
  - cd ${GOPATH}/src/${REPO_NAME}
  - go get -u gopkg.in/yaml.v2

stages:
    - test
    - build
    - publish

format:
    stage: test
    script:
      - go fmt $(go list ./... | grep -v /vendor/)
      - go vet $(go list ./... | grep -v /vendor/)
      - go test -race $(go list ./... | grep -v /vendor/)
    only:
      - /^(release-\d+(\.\d+)|(feature|bugfix|security|hotfix)\/[[:alnum:]](-|[[:alnum:]])*)$/
      - development
      - tags

compile:
    stage: build
    script:
      - go build -race -ldflags "-extldflags '-static'" -o ${CI_PROJECT_DIR}/${BINARY_NAME}
    artifacts:
      name: ${BINARY_NAME}_${CI_COMMIT_REF_SLUG}_${CI_COMMIT_SHORT_SHA}.zip
      paths:
        - ${BINARY_NAME}
    only:
      - /^(release-\d+(\.\d+)|(feature|bugfix|security|hotfix)\/[[:alnum:]](-|[[:alnum:]])*)$/
      - development
      - tags

publish:
  stage: publish
  script:
    - go build -race -ldflags "-extldflags '-static'" -o ${CI_PROJECT_DIR}/${BINARY_NAME}
  artifacts:
    name: ${BINARY_NAME}_${CI_COMMIT_TAG}.zip
    paths:
      - ${BINARY_NAME}
  only:
    - tags
